//
//  UMCNAM_tcapContinue.h
//  cnam-server
//
//  Created by Andreas Fink on 19/04/16.
//  Copyright © 2017 Andreas Fink (andreas@fink.org). All rights reserved.
//


#import <ulibasn1/ulibasn1.h>
#import <ulibgt/ulibgt.h>
#import <ulibsccp/ulibsccp.h>
#import <ulibtcap/ulibtcap.h>
@class UMLayerCNAM;

@interface UMCNAM_tcapContinue : UMLayerTask
{
    UMLayerCNAM *cnam;
    NSString *transactionId;
    NSString *userDialogId;
    UMTCAP_Variant  variant;
    UMTCAP_asn1_objectIdentifier *applicationContext;
    SccpAddress *callingAddress;
    SccpAddress *calledAddress;
    UMLayerTCAP *tcap;
    TCAP_NSARRAY_OF_COMPONENT_PDU *components;
    NSDictionary *options;
}

@property(readwrite,strong) UMLayerCNAM *cnam;
@property(readwrite,strong) NSString *transactionId;
@property(readwrite,strong) NSString *userDialogId;
@property(readwrite,assign) UMTCAP_Variant  variant;
@property(readwrite,strong) UMTCAP_asn1_objectIdentifier *applicationContext;
@property(readwrite,strong) SccpAddress *callingAddress;
@property(readwrite,strong) SccpAddress *calledAddress;
@property(readwrite,strong) UMLayer *tcap;
@property(readwrite,strong) TCAP_NSARRAY_OF_COMPONENT_PDU *components;
@property(readwrite,strong) NSDictionary *options;


- (UMCNAM_tcapContinue *)initForLayer:(UMLayerCNAM *)cnam
                        transactionId:(NSString *)transactionId
                         userDialogId:(NSString *)dialog
                              variant:(UMTCAP_Variant)variant
                   applicationContext:(UMTCAP_asn1_objectIdentifier *)applicationContext
                             userInfo:(UMTCAP_asn1_userInformation *)xuserInfo
                       callingAddress:(SccpAddress *)callingAddress
                        calledAddress:(SccpAddress *)calledAddress
                            tcapLayer:(UMLayerTCAP *)tcapLayer
                           components:(TCAP_NSARRAY_OF_COMPONENT_PDU *)components
                              options:(NSDictionary *)options;

@end
