//
//  UMCNAM_tcapEnd.h
//  cnam-server
//
//  Created by Andreas Fink on 19/04/16.
//  Copyright © 2017 Andreas Fink (andreas@fink.org). All rights reserved.
//


#import <ulibasn1/ulibasn1.h>
#import <ulibgt/ulibgt.h>
#import <ulibsccp/ulibsccp.h>
#import <ulibtcap/ulibtcap.h>
@class UMLayerCNAM;


@interface UMCNAM_tcapEnd : UMLayerTask
{
    UMLayerCNAM *cnam;
    NSString *userDialogId;
    UMTCAP_Variant  variant;
    UMTCAP_asn1_objectIdentifier *applicationContext;
    UMTCAP_asn1_external        *userInfo;
    SccpAddress *callingAddress;
    SccpAddress *calledAddress;
    UMLayerTCAP *tcap;
    TCAP_NSARRAY_OF_COMPONENT_PDU *components;
    NSDictionary *options;
    NSString *tcapTransactionId;
}

@property(readwrite,strong) UMLayerCNAM *cnam;
@property(readwrite,strong) NSString *userDialogId;
@property(readwrite,assign) UMTCAP_Variant  variant;
@property(readwrite,strong) UMTCAP_asn1_objectIdentifier *applicationContext;
@property(readwrite,strong) SccpAddress *callingAddress;
@property(readwrite,strong) SccpAddress *calledAddress;
@property(readwrite,strong) UMLayer *tcap;
@property(readwrite,strong) TCAP_NSARRAY_OF_COMPONENT_PDU *components;
@property(readwrite,strong) NSDictionary *options;
@property(readwrite,strong) NSString *tcapTransactionId;
@property(readwrite,strong) UMTCAP_asn1_external        *userInfo;



- (UMCNAM_tcapEnd *)initForLayer:(UMLayerCNAM *)xcnam
                   transactionId:(NSString *)xtid
                    userDialogId:(NSString *)xdialog
                         variant:(UMTCAP_Variant)xvariant
              applicationContext:(UMTCAP_asn1_objectIdentifier *)xapplicationContext
                        userInfo:(UMTCAP_asn1_userInformation *)xuserInfo
                  callingAddress:(SccpAddress *)xcallingAddress
                   calledAddress:(SccpAddress *)xcalledAddress
                       tcapLayer:(UMLayerTCAP *)xtcap
                      components:(TCAP_NSARRAY_OF_COMPONENT_PDU *)xcomponents
                         options:(NSDictionary *)xoptions;

@end
